// SCENARIOS SCRIPT (v.1.0.0)
// Author: Raunhofer, 2017
// ----------------------------
// How to use:
// Add triggers, name them in the following way: scenario_A_scene_B, where A is the id of the scenario
// and B is the number of scenario scenes. Remember, counting starts from zero (0). Eg. scenario_0_scene_0.
// Then sync objects to these triggers. One object can be synced to multiple triggers.
// One of the scenarios will be chosen and if an object is not part of the selected scenario, it will be
// removed.
// Tip: Use editor layers for different scenarios and sub scenes.
if (!isServer) exitWith {};
private["_id", "_count", "_triggers", "_undefined", "_varName", "_selectedScene"];
{
	_id = _x select 0;
	_count = (_x select 1) - 1;
	_triggers = [];
	_undefined = [];
	for "_i" from 0 to _count do {
		_varName = format["scenario_%1_scene_%2", _id, _i];
		if (!isnil _varName) then {
			_triggers pushBack (call compile _varName);
		} else {
			_undefined pushBack _varName;
		};
	};
	if (count _undefined > 0) exitWith {
		hint format ["SCENARIOS\n\nThe following objects are undefined:\n\n%1", _undefined];
	};
	if (count _triggers < 1) exitWith {};
	_selectedScene = selectRandom _triggers;
	{
		if (_x != _selectedScene) then {
			{
				if (!(_x in synchronizedObjects _selectedScene)) then {
					deleteVehicle _x;
				};
			} forEach synchronizedObjects _x;
		};
	} forEach _triggers;
} forEach _this;
